﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;

namespace WNE_ClickDisabledCheckbox
{
    public partial class Form1 : Form
    {
        private CustomCreationFilter filter;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            filter = new CustomCreationFilter();
            ultraNumericEditor1.CreationFilter = filter;
            filter.CheckBoxClicked += filter_CheckBoxClicked;
        }

        void filter_CheckBoxClicked(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            filter.CurrentState = ((CheckBoxUIElement)e.Element).CheckState;

            // Force the firing of the BeforeEnterEditMode again
            var editorElement = ultraNumericEditor1.UIElement.
                GetDescendant(typeof(EmbeddableUIElementBase)) as EmbeddableUIElementBase;
            if (editorElement != null)
            {
                ultraNumericEditor1.Editor.ExitEditMode(true, true);
                ultraNumericEditor1.Editor.EnterEditMode(editorElement);
            }
        }

        private void ultraNumericEditor1_BeforeEnterEditMode(object sender, CancelEventArgs e)
        {
            e.Cancel = filter.CurrentState == CheckState.Checked;
        }
    }
}
